<?php
/**
  * Plugin Name: Woocommerce Variations Table - Grid
* Plugin URI: http://codecanyon.net/item/woocommerce-variations-to-table-grid/10494620
* Description: Plugin to turn Woocommerce normal variations select menus to table - grid
* Version: 1.2.0
* Author: Spyros Vlachopoulos
* Author URI: http://www.nitroweb.gr
* License: GPL2
* Text Domain: vartable
*/

// Make sure we don't expose any info if called directly
if ( !function_exists( 'add_action' ) ) {
	echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
	exit;
}

if (version_compare(PHP_VERSION, '5.4.0', '<')) {
    if(session_id() == '') {session_start();}
} else  {
   if (session_status() == PHP_SESSION_NONE) {session_start();}
}

// Load plugin textdomain
add_action( 'plugins_loaded', 'vartable_load_textdomain' );
function vartable_load_textdomain() {
  load_plugin_textdomain( 'vartable', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' ); 
  
  remove_action( 'woocommerce_variable_add_to_cart', 'woocommerce_variable_add_to_cart', 30 );
  add_action( 'woocommerce_variable_add_to_cart', 'vt_woocommerce_variable_add_to_cart', 30 );

}


function vartable_activate() {
  
  $vartable_order = array (
    'vartable_sku' => 'SKU',
    'vartable_thumb' => 'Thumbnail',
    'vartable_stock' => 'Stock',
    'vartable_variations' => 'Variations',
    'vartable_price' => 'Price',
    'vartable_offer' => 'Offer Image',
    'vartable_qty' => 'Quantity',
    'vartable_gift' => 'Gift Wrap',
    'vartable_wishlist' => 'Whishlist',
    'vartable_cart' => 'Add to Cart Button'
  );
  
  
  // set options only if they do not exist
  if (get_option('vartable_disabled') === false) {
    update_option( 'vartable_disabled', 0 );
  }
  if (get_option('vartable_thumb') === false) {
    update_option( 'vartable_thumb', 1 );
  }
  if (get_option('vartable_thumb_size') === false) {
    update_option( 'vartable_thumb_size', 80 );
  }
  if (get_option('vartable_price') === false) {
    update_option( 'vartable_price', 1 );
  }
  if (get_option('vartable_cart') === false) {
    update_option( 'vartable_cart', 1 );
  }
  if (get_option('vartable_qty') === false) {
    update_option( 'vartable_qty', 1 );
  }
  if (get_option('vartable_order') === false) {
    update_option( 'vartable_order', $vartable_order );
  }
  if (get_option('vartable_head') === false) {
    update_option( 'vartable_head', 1 );
  }
  if (get_option('vartable_sorting') === false) {
    update_option( 'vartable_sorting', 1 );
  }
  if (get_option('vartable_default_qty') === false) { 
    update_option('vartable_default_qty', 1); 
  }
  if (get_option('vartable_qty_control') === false) { 
    update_option('vartable_qty_control', 0); 
  }
   
}
register_activation_hook( __FILE__, 'vartable_activate' );


include ('grid_options_page.php');

// create the shortcode
function vartable_func( $atts ) {
    $a = shortcode_atts( array(
    'id'              => '',
    'disabled'        => '',
    'categories_exc'  => '',
    'sku'             => '',
    'thumb'           => '',
    'thumb_size'      => '',
    'stock'           => '',
    'in_stock_text'   => '',
    'out_stock_text'  => '',
    'low_stock_text'  => '',
    'low_stock_thresh'=> '',
    'price'           => '',
    'offer'           => '',
    'image'           => '',
    'qty'             => '',
    'default_qty'     => '',
    'cart'            => '',
    'globalcart'      => '',
    'wishlist'        => '',
    'gift'            => '',
    'order'           => '',
    'ajax'            => '',
    'desc'            => '',
    'head'            => '',
    'customhead'      => '',
    'sorting'         => '',
    'shortcd'         => 1
    ), $atts );

    return (vt_woocommerce_variable_add_to_cart($a));
}
add_shortcode( 'vartable', 'vartable_func' );



function vartableall_func( $atts ) {
    $a = shortcode_atts( array(
    'disabled'        => '',
    'categories_exc'  => '',
    'sku'             => '',
    'thumb'           => '',
    'thumb_size'      => '',
    'stock'           => '',
    'in_stock_text'   => '',
    'out_stock_text'  => '',
    'low_stock_text'  => '',
    'low_stock_thresh'=> '',
    'price'           => '',
    'offer'           => '',
    'image'           => '',
    'qty'             => '',
    'default_qty'     => '',
    'cart'            => '',
    'globalcart'      => '',
    'wishlist'        => '',
    'gift'            => '',
    'order'           => '',
    'ajax'            => '',
    'desc'            => '',
    'head'            => '',
    'customhead'      => '',
    'sorting'         => '',
    'shortcd'         => 1
    ), $atts );
    
  $args = array(
    'posts_per_page' => -1, 
    'post_type' => 'product',
    'meta_key'     => '_min_price_variation_id',
    'meta_value'   => 0,
    'meta_compare' => '>'
  );
  $posts_array = get_posts( $args ); 
  
  $alltables = '';
  
  foreach ( $posts_array as $post ) {
    
    $a['id'] = $post->ID;
    $alltables .= vt_woocommerce_variable_add_to_cart($a);
  }
  


  return ($alltables);
}
add_shortcode( 'vartableall', 'vartableall_func' );



function vt_woocommerce_variable_add_to_cart($allsets) {
  global $product, $post, $woocommerce;
  
  $out = '';
  $form = '';
  $vtrand = rand(1, 100000);
  
  
  // get values from shortcode
  if ($allsets) {
    $vartable_id              = $allsets['id'];
    $vartable_disabled        = $allsets['disabled'];
    $vartable_categories_exc  = $allsets['categories_exc'];
    $vartable_sku             = $allsets['sku'];
    $vartable_thumb           = $allsets['thumb'];
    $vartable_thumb_size      = $allsets['thumb_size'];
    $vartable_stock           = $allsets['stock'];
    $vartable_in_stock_text   = $allsets['in_stock_text'];
    $vartable_out_stock_text  = $allsets['out_stock_text'];
    $vartable_low_stock_text  = $allsets['low_stock_text'];
    $vartable_low_stock_thresh= $allsets['low_stock_thresh'];
    $vartable_hide_zero       = $allsets['hide_zero'];
    $vartable_price           = $allsets['price'];
    $vartable_offer           = $allsets['offer'];
    $vartable_image           = $allsets['image'];
    $vartable_qty             = $allsets['qty'];
    $vartable_default_qty     = $allsets['default_qty'];
    $vartable_qty_control     = $allsets['vartable_qty_control'];
    $vartable_cart            = $allsets['cart'];
    $vartable_globalcart      = $allsets['globalcart'];
    $vartable_wishlist        = $allsets['wishlist'];
    $vartable_gift            = $allsets['gift'];
    $vartable_order           = $allsets['order'];
    $vartable_ajax            = $allsets['ajax'];
    $vartable_desc            = $allsets['desc'];
    $vartable_head            = $allsets['head'];
    $vartable_customhead      = $allsets['customhead'];
    $vartable_sorting         = $allsets['sorting'];
    $vartable_shortcd         = $allsets['shortcd'];
  } else {
    $vartable_id              = null;
    $vartable_disabled        = null;
    $vartable_categories_exc  = null;
    $vartable_sku             = null;
    $vartable_thumb           = null;
    $vartable_thumb_size      = null;
    $vartable_stock           = null;
    $vartable_in_stock_text   = null;
    $vartable_out_stock_text  = null;
    $vartable_low_stock_text  = null;
    $vartable_low_stock_thresh= null;
    $vartable_hide_zero       = null;
    $vartable_price           = null;
    $vartable_offer           = null;
    $vartable_image           = null;
    $vartable_qty             = null;
    $vartable_default_qty     = null;
    $vartable_qty_control     = null;
    $vartable_cart            = null;
    $vartable_globalcart      = null;
    $vartable_wishlist        = null;
    $vartable_gift            = null;
    $vartable_order           = null;
    $vartable_ajax            = null;
    $vartable_desc            = null;
    $vartable_head            = null;
    $vartable_customhead      = null;
    $vartable_sorting         = null;
    $vartable_shortcd         = null;
  }
  
  // check if it is a shortcode and if an id has been set
  if ($vartable_id != null) {
    $_pf = new WC_Product_Factory();  
    $product = $_pf->get_product($vartable_id);
  }
  
  if (!is_object($product)) {
    return (__('No product object found', 'vartable'));
  }
  
  $product_cats = wp_get_post_terms( $product->id, 'product_cat' );
  // get all ids
  foreach($product_cats as $pcdata) {
    $pcids[] = $pcdata->term_id;
  }
    

  // make sure that quantity is set
  if (get_option('vartable_default_qty') === false) { update_option('vartable_default_qty', 1); }
  if (get_option('vartable_qty_control') === false) { update_option('vartable_qty_control', 0); }
    
    
    $vartable_disabled        = ($vartable_disabled == null         ? get_option('vartable_disabled') : $vartable_disabled);
    $vartable_categories_exc  = ($vartable_categories_exc == null   ? get_option('vartable_categories_exc') : $vartable_categories_exc);
    $vartable_sku             = ($vartable_sku == null              ? get_option('vartable_sku') : $vartable_sku);
    $vartable_thumb           = ($vartable_thumb == null            ? get_option('vartable_thumb') : $vartable_thumb);
    $vartable_thumb_size      = ($vartable_thumb_size == null       ? get_option('vartable_thumb_size') : $vartable_thumb_size);
    $vartable_stock           = ($vartable_stock == null            ? get_option('vartable_stock') : $vartable_stock);
    $vartable_in_stock_text   = ($vartable_in_stock_text == null    ? get_option('vartable_in_stock_text') : $vartable_in_stock_text);
    $vartable_out_stock_text  = ($vartable_out_stock_text == null   ? get_option('vartable_out_stock_text') : $vartable_out_stock_text);
    $vartable_low_stock_text  = ($vartable_low_stock_text == null   ? get_option('vartable_low_stock_text') : $vartable_low_stock_text);
    $vartable_low_stock_thresh= ($vartable_low_stock_thresh == null ? get_option('vartable_low_stock_thresh') : $vartable_low_stock_thresh);
    $vartable_hide_zero       = ($vartable_hide_zero == null        ? get_option('vartable_hide_zero') : $vartable_hide_zero);
    $vartable_price           = ($vartable_price == null            ? get_option('vartable_price') : $vartable_price);
    $vartable_offer           = ($vartable_offer == null            ? get_option('vartable_offer') : $vartable_offer);
    $vartable_image           = ($vartable_image == null            ? get_option('vartable_image') : $vartable_image);
    $vartable_qty             = ($vartable_qty == null              ? get_option('vartable_qty') : $vartable_qty);
    $vartable_default_qty     = ($vartable_default_qty == null      ? get_option('vartable_default_qty') : $vartable_default_qty);
    $vartable_qty_control     = ($vartable_qty_control == null      ? get_option('vartable_qty_control') : $vartable_qty_control);
    $vartable_cart            = ($vartable_cart == null             ? get_option('vartable_cart') : $vartable_cart);
    $vartable_globalcart      = ($vartable_globalcart == null       ? get_option('vartable_globalcart') : $vartable_globalcart);
    $vartable_wishlist        = ($vartable_wishlist == null         ? get_option('vartable_wishlist') : $vartable_wishlist);
    $vartable_gift            = ($vartable_gift == null             ? get_option('vartable_gift') : $vartable_gift);
    $vartable_order           = ($vartable_order == null            ? get_option('vartable_order') : $vartable_order);
    $vartable_ajax            = ($vartable_ajax == null             ? get_option('vartable_ajax') : $vartable_ajax);
    $vartable_desc            = ($vartable_desc == null             ? get_option('vartable_desc') : $vartable_desc);
    $vartable_head            = ($vartable_head == null             ? get_option('vartable_head') : $vartable_head);
    $vartable_customhead      = ($vartable_customhead == null       ? get_option('vartable_customhead') : $vartable_customhead);
    $vartable_sorting         = ($vartable_sorting == null          ? get_option('vartable_sorting') : $vartable_sorting);
    
    // gift wrap option
    $default_message            = '{checkbox} '. sprintf( __( 'Gift wrap this item for %s?', 'woocommerce-product-gift-wrap' ), '{price}' );
    $gift_wrap_enabled          = get_option( 'product_gift_wrap_enabled' ) == 'yes' ? true : false;
		$gift_wrap_cost             = get_option( 'product_gift_wrap_cost', 0 );
		$product_gift_wrap_message  = get_option( 'product_gift_wrap_message');
    
    if ( ! $product_gift_wrap_message ) {
			$product_gift_wrap_message = $default_message;
		}
    
    $is_wrappable = get_post_meta( $product->id, '_is_gift_wrappable', true );
    
		if ( $is_wrappable == '' && $gift_wrap_enabled ) {
			$is_wrappable = 'yes';
		}
    
    //  if the table is disabled for this product display the default select menus
    $checkcat = array();
    if (is_array($vartable_categories_exc) && is_array($pcids)) {
      $checkcat = array_intersect($pcids, $vartable_categories_exc);
    }
    if ( ((get_post_meta($product->id, 'disable_variations_table', true) == 1 || !empty($checkcat)) || $vartable_disabled == 1) && $vartable_shortcd != 1) {
      // Enqueue variation scripts
      wp_enqueue_script( 'wc-add-to-cart-variation' );

      // Load the template
      wc_get_template( 'single-product/add-to-cart/variable.php', array(
          'available_variations'  => $product->get_available_variations(),
          'attributes'   			=> $product->get_variation_attributes(),
          'selected_attributes' 	=> $product->get_variation_default_attributes()
        ) );
      return;
    }
  
    if (method_exists($product,'get_variation_attributes')) {
      $varattr = $product->get_variation_attributes();
    } else {
      return (__('This is not a variable product', 'vartable'));
    }
    
    $default_feat_image = wp_get_attachment_image_src( get_post_thumbnail_id($product->id, array($vartable_thumb_size, $vartable_thumb_size)) );
    $default_feat_imagefull = wp_get_attachment_image_src( get_post_thumbnail_id($product->id), 'full' );
    
		$variations = $product->get_available_variations();    
    
    
    // if ( current_user_can( 'manage_options' ) ) { echo '<pre>'. print_r($variations, true) .'</pre><hr />'; }

    // prepare arrays to use that will hold data
    $anyvariations = array();
    $standardvariations = array();
    $fullvariations = array();
    
    // get all attributes that are valid
    $attr_keys = array_keys($product->get_attributes());
    $attr_keys2 = array();
    foreach ($attr_keys as $atkey) {
      $attr_keys2[] = str_replace(array('attribute_', 'pa_'), array('',''), $atkey);
    }

    foreach ($variations as $key => $value) {
      
      foreach ($value['attributes'] as $attr_key => $attr_value) {
        
        // skip attributes that are empty and have not been set, mostly created by import plugins
        if (!in_array(str_replace(array('attribute_', 'pa_'), array('',''), $attr_key), $attr_keys2)) { continue; }
        
        if ($attr_value == '') {
          $anyvariations[$key][$value['variation_id']][str_replace('attribute_', '', $attr_key)] = $varattr[str_replace('attribute_', '', $attr_key)];
        } else {
          $standardvariations[$key][$value['variation_id']][str_replace('attribute_', '', $attr_key)] = array($attr_value);
        }
      }
    }

    
    // get variations that have all attributes set
    $fullvariations = array_diff_key($standardvariations, $anyvariations);
    
    $combinationarray = array();
    $combinationsresults = array();
    foreach ($anyvariations as $attrkey => $variat) {
      reset($variat);
      $variationid = key($variat);
      $countvariations = count($variat[$variationid]);
      if (is_array($standardvariations[$attrkey]) && is_array($variat[$variationid])) {
        $combinationarray[$attrkey] = $standardvariations[$attrkey][$variationid] + $variat[$variationid] ;
      }
      if (!is_array($variat[$variationid])) {
        $combinationarray[$attrkey] = $standardvariations[$attrkey][$variationid];
      }
      if (!is_array($standardvariations[$attrkey][$variationid])) {
        $combinationarray[$attrkey] = $variat[$variationid];
      }
      
    }

    // get all possible combinations for the attributes set as any
    foreach($combinationarray as $attrkey => $combarrays) {
      // more than one attribute is set on the variation
      if (count($combarrays) > 1) {
        $combinationsresults[$attrkey] = vartable_combinations($combarrays);
      } else { // ONLY ONE attribute is set on the variation
        if (is_array($combarrays)) {
          foreach($combarrays as $singleattkey => $singleattval) {
            if (is_array($singleattval)) {
              foreach($singleattval as $thesingleattr) {
                $combinationsresults[$attrkey][][$singleattkey] = $thesingleattr;
              }
            }
          }
        }
      }
    }

    $finalattr = array();
    $i = 0;
    
    // add variations that have all attributes set to the final array
    foreach ($fullvariations as $fkey => $fvalue) {
      $finalattr[$i] = $variations[$fkey];
      $i++;
    }
    
    // add variations that have attributes set as any the final array
    foreach ($combinationsresults as $attrkey => $combinations) {
    
      foreach ($combinations as $combinationsvalues) {
        $finalattr[$i] = $variations[$attrkey];
        if (is_array($combinationsvalues)) {
          foreach ($combinationsvalues as $attrshortkey => $attrstringvalue) {
            $finalattr[$i]['attributes']['attribute_'.$attrshortkey] = $attrstringvalue;
          }
        }
        // if (!is_array($combinationsvalues)) {
          // have to check this
        // }
        $i++;
      }
    }
    
    $attr_ordernames = array();
    foreach ($product->get_attributes() AS $ankey => $akval) {
      if ($akval['is_variation'] == 1) {
        $attr_ordernames[str_replace(array('_', '.', ' '),array('-', '-', '-'),sanitize_title(str_replace('attribute_', '', $ankey)))] = wc_attribute_label( $akval['name'] );
      }
    }
    
   
    
    // order of attributes
    $attr_order = array();
    foreach ($varattr as $attrkey => $attrvalues) {
      $attr_order[] = 'attribute_'.sanitize_title($attrkey);
    }
    
    $anyextraimg = 0;
    $head = '';
    
    ob_start();
    do_action('woocommerce_before_add_to_cart_form', $product->id);
    $woocommerce_before_add_to_cart_form = ob_get_clean();
    $out .= $woocommerce_before_add_to_cart_form;
    
    ob_start();
    do_action('vartable_before_table', $product->id);
    $vartable_before_table = ob_get_clean();
    $out .= $vartable_before_table;
    
    ob_start();
    do_action('vartable_table_class', $product->id);
    $vartable_table_class = ob_get_clean();
    
    $out .= '
    <table id="tb_'. $vtrand .'" class="table vartable '. $vartable_table_class .'">
    
      %headplaceholder%
    ';    
    
    $out .= '<tbody>
      ';
    
// echo vtdb($finalattr);


    

    
    // get order / position of the variations to display the table rows        
    $moi = 0;
    $mo_reset = 0;
    $menu_order = array();
    foreach ($finalattr as $vt_variation_array) {
      $vt_variation_object = get_post($vt_variation_array['variation_id']);
      
      if ($mo_reset != $vt_variation_object->menu_order && $vt_variation_object->menu_order != 0) {
        $mo_reset = $vt_variation_object->menu_order;
        $moi = 0;
      }
      $menu_order[$vt_variation_array['variation_id']] = ($vt_variation_object->menu_order * 100) + $moi++;
    }
    
    $ri = 0;
    $vt_trows = array();
		foreach ($finalattr as $key => $value) {
      
      // create an array to hold all TDs
      $allcolumns = array();
      
      $product_variation = new WC_Product_Variation($value['variation_id']);
      
      if (!($product_variation->get_price() > 0) && $vartable_hide_zero == 1) { continue; }
      
      $varstock = $product_variation->get_stock_quantity();

      if (!isset($vt_trows[$menu_order[$value['variation_id']]])) {
        $vt_trows[$menu_order[$value['variation_id']]] = '';
      }
      
      ob_start();
      do_action('woocommerce_before_single_variation', $product->id, $value);
      $woocommerce_before_single_variation = ob_get_clean();
      
      ob_start();
      do_action('vartable_inside_add_to_cart_form', $product->id, $value);
      $vartable_inside_add_to_cart_form = ob_get_clean();
      
      $vt_trows[$menu_order[$value['variation_id']]] .= $woocommerce_before_single_variation .'<tr class="'. $value['variation_id'] .' '.(get_post_meta($value['variation_id'], '_stock_status', true) != 'outofstock' ? 'instock' : 'outofstock') .'">
          ';  
    
		$form .= '
		<form action="'. esc_url( $product->add_to_cart_url() ) .'" method="POST" data-variation_id="'.  $value['variation_id'].$ri .'" id="vtvariation_'. $value['variation_id'].$ri .'" class="vtajaxform" enctype="multipart/form-data">
			<input type="hidden" name="variation_id" value="'. $value['variation_id'] .'" />
			<input type="hidden" name="product_id" value="'. esc_attr( $product->id ) .'" />
			<input type="hidden" name="add-to-cart" value="'. esc_attr( $product->id ) .'" />
      '. $vartable_inside_add_to_cart_form .'
      ';
      
      if ($value['is_in_stock'] == 1 || !empty($value['backorders_allowed'])) {
        $form .= '<input type="hidden" class="hidden_quantity" name="quantity" value="'. apply_filters('vartable_default_qty', $vartable_default_qty, $value) .'" />';
      }
      
      $form .= '<input type="hidden" class="gift_wrap" name="gift_wrap" value="" />';
      
			if(!empty($value['attributes'])){
				foreach ($value['attributes'] as $attr_key => $attr_value) {
          if ($attr_value != '') {
				
				$form .= '<input type="hidden" name="'. $attr_key .'" value="'. $attr_value .'" />
        ';
				
          }
				}
			}
			
      $headenames = fields_func();
      
					
          
            if ($vartable_sku == 1) {
              $allcolumns['vartable_sku'] = '<td class="skucol" data-label="'. apply_filters('vartable_dl_sku', $headenames['vartable_sku'], $value) .'">'. $value['sku'] .'</td>';
            }

            if ($vartable_thumb == 1) {
              $rowimg = '';
              $var_feat_image = wp_get_attachment_image_src(get_post_thumbnail_id($value['variation_id']), array($vartable_thumb_size, $vartable_thumb_size));
              $var_feat_image_full = wp_get_attachment_image_src(get_post_thumbnail_id($value['variation_id']), 'full');
              if (!empty($var_feat_image)) { 
                $rowimg = $var_feat_image; 
              } else {
                $rowimg = $default_feat_image;
              }
              
              if (!empty($var_feat_image_full)) { 
                $rowimgfull = $var_feat_image_full; 
              } else {
                $rowimgfull = $default_feat_imagefull;
              }
            
              if (isset($rowimg[0])) {
                $allcolumns['vartable_thumb'] = '<td class="thumbcol"  data-label="'. apply_filters('vartable_dl_thumb', $headenames['vartable_thumb'], $value) .'">
                  <a href="'. $rowimgfull[0] .'" itemprop="image" class="variationimg zoom '. apply_filters( 'vartable_thumb_class_filter', 'thumb', $value) .'" title="'. $product->post->post_title .' - '.implode(' - ', $value['attributes']) .'"  data-rel="prettyPhoto">
                    <img src="'. $rowimg[0] .'" alt="'. $product->post->post_title .' - '.implode(' - ', $value['attributes']) .'" width="'. $rowimg[1] .'" height="'. $rowimg[2] .'" style="width: '. $vartable_thumb_size.'px; height: auto;" />
                  </a>
                </td>';
              } else {
                $allcolumns['vartable_thumb'] = '<td class="thumbcol" data-label="'. apply_filters('vartable_dl_thumb', $headenames['vartable_thumb'], $value) .'">
                  '. apply_filters( 'woocommerce_single_product_image_html', sprintf( '<img src="%s" alt="%s" style="width: '. $vartable_thumb_size.'px; height: auto;" />', wc_placeholder_img_src(), __( 'Placeholder', 'woocommerce' ) ), $product->ID ).'
                  </td>';
              }
          
          
            }
          ?>
          
          <?php
            if ($vartable_stock == 1) {

              if (absint($vartable_low_stock_thresh) > 0 && $varstock < absint($vartable_low_stock_thresh) && get_post_meta($value['variation_id'], '_manage_stock', true) == 'yes' ) {
                $allcolumns['vartable_stock'] = '<td class="stockcol" data-label="'. apply_filters('vartable_dl_stock', $headenames['vartable_stock'], $value) .'">'. (get_post_meta($value['variation_id'], '_stock_status', true) != 'outofstock' && $varstock > 0 ? '<span class="lowstock">'. str_replace ('%n', $varstock, __($vartable_low_stock_text, 'vartable')) .'</span>' : '<span class="outofstock">'.__($vartable_out_stock_text, 'vartable').'</span>') .'</td>';
              } else {
                $allcolumns['vartable_stock'] = '<td class="stockcol" data-label="'. apply_filters('vartable_dl_stock', $headenames['vartable_stock'], $value) .'">'. (get_post_meta($value['variation_id'], '_stock_status', true) != 'outofstock' ? '<span class="instock">'. str_replace ('%n', $varstock, __($vartable_in_stock_text, 'vartable')) .'</span>' : '<span class="outofstock">'.__($vartable_out_stock_text, 'vartable').'</span>') .'</td>';
              }
              
            }
          ?>
          <?php
            // get attribute names
            $attrnames = array();
            $orderedattributes = array_merge(array_flip($attr_order), $value['attributes']);
            
            
            
            foreach ($orderedattributes as $taxon => $taxval) {
              
              $taxonkey = sanitize_title(str_replace(array('-', '.', ' '),array('_', '_', '_'),$taxon));

              $temp = '';
              $temp = get_term_by('slug', $taxval, str_replace('attribute_', '', $taxon));
              // echo vtdb($taxval);
              if ($temp !== false) {
                
                $attrnames[$taxonkey] = apply_filters( 'woocommerce_variation_option_name', $temp->name, $value);
                
              } else {
                // get all custom attributes sanitize_title
                $allcustomattr = explode('|',$product->get_attribute( str_replace('attribute_', '', $taxon) ));
                $customattrnames = array();
                
                foreach ($allcustomattr as $customattrname) {
                  // echo vtdb(sanitize_title(trim($customattrname)));
                  $customattrnames[sanitize_title(trim($customattrname))] = apply_filters( 'woocommerce_variation_option_name', $customattrname, $value);
                }
                // var_dump($taxval);
                if ($taxval && isset($customattrnames[sanitize_title(trim($taxval))])) {
                  
                  $attrnames[$taxonkey] = apply_filters( 'woocommerce_variation_option_name', $customattrnames[sanitize_title(trim($taxval))], $value);
                }
                
              }
            }
          
            // removed on version 1.1.6
						// $allcolumns['vartable_variations'] = '<td class="optionscol" data-label="'. $headenames['vartable_variations'] .'">
              // '. implode( apply_filters( 'vartable_attributes_join', '</td><td>'), apply_filters( 'vartable_attributes_array', $attrnames)) .'
            // </td>
            // ';
                        
            $attrnames = apply_filters( 'vartable_attributes_array', $attrnames, $value);
            
            
            foreach($attrnames as $attr_slug => $attr_td_value) {
              
              if (!isset($allcolumns['vartable_variations'])) {
                $allcolumns['vartable_variations'] = '';
              }
                            
              $allcolumns['vartable_variations'] .= apply_filters( 'vartable_attributes_join', '<td class="optionscol '. $attr_slug .'" data-label="'. apply_filters('vartable_dl_options', $attr_ordernames[str_replace(array('_', '.', ' '),array('-', '-', '-'),sanitize_title(str_replace('attribute_', '', $attr_slug)))]) .'">'. $attr_td_value .'</td>', $value);
            }
            
            if ($vartable_price == 1) {
              $allcolumns['vartable_price'] = '
              <td class="pricecol" data-label="'. apply_filters('vartable_dl_price', $headenames['vartable_price'], $value) .'" data-sort-value="'. $product_variation->get_display_price() .'">
                '. $product_variation->get_price_html() .'
              </td>';
            }
          
            $override_extra_image = get_post_meta($value['variation_id'], 'override_extra_image', true);
            $enable_extra_image = get_post_meta($value['variation_id'], 'enbable_variations_table_img', true);
            $vartable_qty_step = get_post_meta($value['variation_id'], 'vartable_qty_step', true);
            
            // if not set, then set it to 1
            if (intval($vartable_qty_step) == 0) { $vartable_qty_step = 1; }
            
            
            if (get_post_meta( $product->id, 'disable_variations_table_offer', true ) != 1) {
            
              if (($vartable_offer == 1 && $enable_extra_image != 'no') || $enable_extra_image == 'yes' && ($vartable_image !='' || $override_extra_image != '')) {
                
                $allcolumns['vartable_offer'] = '<td class="offercol"  data-label="'. apply_filters('vartable_dl_offer', $headenames['vartable_offer'], $value) .'">';
                
                $anyextraimg = 1;
                if (!empty($override_extra_image)) {
                  $allcolumns['vartable_offer'] .= '<img src="'. $override_extra_image .'" alt="'.  __('offer', 'vartable') .'" />';
                } else {
                  $allcolumns['vartable_offer'] .= '<img src="'. $vartable_image .'" alt="'.  __('offer', 'vartable') .'" />';
                }
                
                $allcolumns['vartable_offer'] .= '</td>';
              }
            }
            

            if ($vartable_qty == 1) {
              $allcolumns['vartable_qty'] = '
              <td class="qtycol" data-label="'. apply_filters('vartable_dl_qty', $headenames['vartable_qty'], $value) .'">';
                if ($value['is_in_stock'] == 1 || !empty($value['backorders_allowed'])) {
                  
                  if ($vartable_qty_control == 1) {
                  
                    $allcolumns['vartable_qty'] .= '
                    <div class="qtywrap">
                    ';
                    
                    $allcolumns['vartable_qty'] .= '
                    <div class="minusqty qtycontrol">-</div>
                    ';
                  
                  }
                  
                  $allcolumns['vartable_qty'] .= '
                    <input type="number" step="'. apply_filters('vartable_qty_step', $vartable_qty_step, $value) .'" name="var_quantity" value="'. apply_filters('vartable_default_qty', $vartable_default_qty, $value) .'" title="Qty" class="input-text qty text" size="4" '. (intval($value['min_qty']) > 0 && !isset($vartable_default_qty) ? 'min="'. $value['min_qty'] .'"': 'min="0"') .' '. (intval($value['max_qty']) > 0 ? 'max="'. $value['max_qty'] .'"': '') .'>
                  ';
                
                  if ($vartable_qty_control == 1) {
                
                    $allcolumns['vartable_qty'] .= '
                      <div class="plusqty">+</div>
                    ';
                    
                    $allcolumns['vartable_qty'] .= '
                      </div>
                    ';
                    
                  }
                }
              $allcolumns['vartable_qty'] .= '</td>';
            }
            
            
          ob_start();
          do_action('woocommerce_add_to_cart_class', $product->id, $value);
          $woocommerce_add_to_cart_class = ob_get_clean();
          
          ob_start();
          do_action('woocommerce_before_add_to_cart_button', $product->id, $value);
          $woocommerce_before_add_to_cart_button = ob_get_clean();
          
          $allcolumns['vartable_cart'] = '<td class="cartcol '. ($vartable_cart == 0 ? 'vartablehide' : '') .' '. $woocommerce_add_to_cart_class .'" data-label="">'.$woocommerce_before_add_to_cart_button;
          if (get_post_meta($value['variation_id'], '_stock_status', true) != 'outofstock' || !empty($value['backorders_allowed'])) { 
            if (get_post_meta($value['variation_id'], '_stock_status', true) != 'instock' && !empty($value['backorders_allowed'])) { 
              $carttext = __( 'Backorder', 'vartable' ); 
            } else { 
              $carttext = __('Add to cart', 'vartable' ); 
            }  
            $allcolumns['vartable_cart'] .= $form.'
              <button id="add2cartbtn_'. $value['variation_id'].$ri .'" type="submit" data-product_id="'. $value['variation_id'] .'" class="single_add_to_cart_button button alt ajax add_to_cart">'. apply_filters('single_add_to_cart_text', $carttext, $product->product_type, $value) .'</button>';
            $allcolumns['vartable_cart'] .= (($vartable_ajax == 1 || $vartable_globalcart == 1) ? '<div class="added2cartwrap" id="added2cart_'.$value['variation_id'].$ri.'"><span class="added2cart" >&#10003;</span></div>' : '');
          }
          
          ob_start();
          do_action('woocommerce_after_add_to_cart_button', $product->id, $value);
          $woocommerce_after_add_to_cart_button = ob_get_clean();
          
          $allcolumns['vartable_cart'] .= $woocommerce_after_add_to_cart_button .'</form></td>';
          
          // empty $form
          $form = '';
          
          if ($vartable_globalcart == 1) {
            
            $allcolumns['vartable_globalcart'] = '<td class="globalcartcol" data-label="">';
            if (get_post_meta($value['variation_id'], '_stock_status', true) != 'outofstock' || !empty($value['backorders_allowed'])) {   
              $allcolumns['vartable_globalcart'] .= '  <input type="checkbox" class="globalcheck" name="check_'. $value['variation_id'].$ri .'" value="1">';
            }
            $allcolumns['vartable_globalcart'] .= '</td>';
          }
          
          if ($vartable_wishlist == 1) {
            $url=strtok($_SERVER["REQUEST_URI"],'?');
            parse_str($_SERVER['QUERY_STRING'], $query_string);
            $query_string['add_to_wishlist'] = basename($value['variation_id']);
            $rdr_str = http_build_query($query_string);
          
          $allcolumns['vartable_wishlist'] = '
            <td class="wishcol" data-label="'. apply_filters('vartable_dl_wishlist', $headenames['vartable_wishlist'], $value) .'">
              <a href="'. $url.'?'.$rdr_str .'" title="'. __('Add to Wishlist', 'vartable') .'">&#10084;</a>
            </td>';
          }
          
          
          if ( $is_wrappable == 'yes' && $vartable_gift == 1) {
            
            $current_value = ! empty( $_REQUEST['gift_wrap'] ) ? 1 : 0;

            $cost = get_post_meta( $product->id, '_gift_wrap_cost', true );

            if ( $cost == '' ) {
              $cost = $gift_wrap_cost;
            }

            $price_text = $cost > 0 ? woocommerce_price( $cost ) : __( 'free', 'woocommerce-product-gift-wrap' );
            $checkbox   = '<input type="checkbox" class="var_gift_wrap" name="var_gift_wrap" value="yes" ' . checked( $current_value, 1, false ) . ' />';
            
            $allcolumns['vartable_gift'] = '
            <td class="giftcol" data-label="'. apply_filters('vartable_dl_gift', $headenames['vartable_gift'], $value) .'">
              <label>'.  str_replace(array('{price}', '{checkbox}',), array($price_text, $checkbox), $product_gift_wrap_message) .'</label>
            </td>';          
          
          }
          

          // order columns
          $orderedcols = array();
          if (is_array($vartable_order)) {
            foreach ($vartable_order as $vokey => $vovalue) {
              if (isset($allcolumns[$vokey])) {
                $orderedcols[$vokey] = $allcolumns[$vokey];
              }
            }
          } else {
            $orderedcols = $allcolumns;
          }
          
          $orderedcols = array_filter($orderedcols);
          $vt_trows[$menu_order[$value['variation_id']]] .= implode ("\n", apply_filters('vartable_output_array', $orderedcols, $value, $attrnames));
          $ri++;
          
          ob_start();
          do_action('woocommerce_after_single_variation', $product->id, $value);
          $woocommerce_after_single_variation = ob_get_clean();

					$vt_trows[$menu_order[$value['variation_id']]] .= '</tr>'.$woocommerce_after_single_variation.'
          ';
            // add description last
            $vt_variation_description = '';
            $vt_variation_description = get_post_meta($value['variation_id'], 'vt_variation_description', true);
            if ($vartable_desc == 1 && $vt_variation_description != '') {
              $vt_trows[$menu_order[$value['variation_id']]] .= '
              <tr class="descrow">
                <td class="desccol" colspan="'. (count($orderedcols) + count($attrnames) - 1) .'" data-label="'. apply_filters('vartable_dl_desc', $headenames['vartable_desc'], $value) .'">'. $vt_variation_description .'</td>
              </tr>';
            }

          

		
		}
    
    
    $out .= implode ("\n", apply_filters('vartable_output_rows_by_id', $vt_trows, $product->id));
    
    // check if the settings should redirect to the cart
    $cartredirect = WC_Admin_Settings::get_option( 'woocommerce_cart_redirect_after_add' );
    if ($cartredirect == 'no') {
      $wheretoredirect = 'location.reload()';
    }
    if ($cartredirect == 'yes') {
      $wheretoredirect = 'window.location.href = "'. $woocommerce->cart->get_cart_url() .'"';
    }
    
    $giftwrap_js = '';
    if ( $is_wrappable == 'yes' && $vartable_gift == 1) {
    
    $giftwrap_js = '
      jQuery("input.var_gift_wrap").on("change", function() {
        if(jQuery(this).is(":checked")) {
          jQuery(this).parent().parent().parent().find(".cartcol input.gift_wrap").val("yes");
        } else {
          jQuery(this).parent().parent().parent().find(".cartcol input.gift_wrap").attr("value", "");
        }
      });
    ';
        
    }
    
    $sorting_js = '';
    if (get_option('vartable_sorting') == 1) {
      $sorting_js = '
        jQuery("#tb_'. $vtrand .'").stupidtable();
      ';
    }
    
    $sorting_js = apply_filters( 'vartable_sorting_js', $sorting_js, $product->id);
    
    ob_start();
    do_action('woocommerce_after_add_to_cart_form', $product->id);
    $woocommerce_after_add_to_cart_form = ob_get_clean();
    
    $out .= '</tbody>
    </table>
    '. $woocommerce_after_add_to_cart_form.'
    <script>
      jQuery(document).ready(function() {
        
        
        if (jQuery("div.qtywrap").length > 0) {
          jQuery("#tb_'. $vtrand .' div.qtywrap").each(function() {
            var qtythis = jQuery(this);
            qtythis.find(".minusqty").on("click", function() {
              var valnum = parseInt(qtythis.find("input").val());
              qtythis.find("input").val(valnum - 1);
            });
            qtythis.find(".plusqty").on("click", function() {
              var valnum = parseInt(qtythis.find("input").val());
              qtythis.find("input").val(valnum + 1);
            });
          });
        }
        
        jQuery("input.input-text.qty").on("change", function() {
          jQuery(this).parent().parent().find(".cartcol input.hidden_quantity").val(jQuery(this).val());
        });
        
        '. $giftwrap_js .'
        '. $sorting_js .'
        
        jQuery("input.input-text.qty").on("change", function() {
          jQuery(this).parent().parent().find(".cartcol input.hidden_quantity").val(jQuery(this).val());
        });
        
        jQuery(".vartable_selectall_check").on("change", function(event) {

          var said = jQuery(this).attr("id").split("_");

          if(this.checked) {
            jQuery("table#tb_"+ said[1] +" tr").each(function(index) {
              
              if(jQuery(this).find("input.globalcheck").length > 0) {
              
                jQuery(this).find("input.globalcheck").attr("checked", "checked");
              }          
              
            });
          } else {
            jQuery("table#tb_"+ said[1] +" tr").each(function(index) {
            
              if(jQuery(this).find("input.globalcheck").length > 0) {
                jQuery(this).find("input.globalcheck").removeAttr("checked");
              }
              
            });
          }
        });
      });
    </script>
    ';
    
    if ($vartable_globalcart == 1) {
      
      ob_start();
      do_action('vartable_add_gc_button', $product->id);
      $vartable_add_gc_button = ob_get_clean();
 
      $out .= '
        <div class="gc_wrap">
          <a href="#globalcart" class="globalcartbtn submit btn alt" data-product_id="gc_'.$product->id .'" id="gc_'. $vtrand .'" class="btn button alt">'. __('Add selected to cart', 'vartable') .'</a>
          <span class="added2cartglobal added2cartglobal_'. $vtrand .'">&#10003;</span>
          <span class="vtspinner vtspinner_'. $vtrand .'"><img src="'. plugins_url('images/spinner.png', __FILE__) .'" width="16" height="16" alt="spinner" /></span>
        </div>
        <script type="text/javascript">
          jQuery(document).ready(function() {
              jQuery("a#gc_'. $vtrand .''. $vartable_add_gc_button .'").on("click", function(event) {
              
                event.preventDefault();
                
                var clickthis = jQuery(this);
                var pid = clickthis.attr("id").split("_");
                jQuery(".vtspinner_"+ pid[1]).fadeIn(100, function() {
                
                  
                  var count = jQuery("table#tb_"+ pid[1] +" tr").not(".descrow").length;
                  // console.log("rows: "+ count);
                  var trig = 0;
                  jQuery.ajaxSetup({ async: false });
                  jQuery("table#tb_"+ pid[1] +" tr").not(".descrow").each(function(index) {
                    if(jQuery(this).find("input.globalcheck").length > 0 && jQuery(this).find("input.globalcheck").is(":checked") && jQuery(this).find("input.qty").val() > 0) {
                      var vpid = jQuery(this).find("input.globalcheck").attr("name").split("_");
                      // jQuery("#add2cartbtn_"+vpid[1]).trigger("click");
                      // jQuery("#vtvariation_"+vpid[1]).submit();
                      jQuery(this).find(".single_add_to_cart_button").trigger("click");
                      // console.log(jQuery("#add2cartbtn_"+vpid[1]).text());
                      trig = 1;                    
                    }
                    count = count - 1;
                    // console.log(count);
                    '. ($vartable_ajax != 1 || $cartredirect == 'yes' ? 'if (count <= 0 && trig == 1) {'. $wheretoredirect .'; } ' : '' ) .'
                    if (count <= 0 || trig == 0) { jQuery(".vtspinner_"+ pid[1]).stop(true, true).fadeOut(100); }
                    if (trig == 1)  { jQuery(".added2cartglobal_"+ pid[1]).stop(true).fadeIn(200); jQuery(".added2cartglobal_"+ pid[1]).delay(3000).fadeOut(200); }
                  });
                });
              });
          });
        </script>
      ';
    }
    if ($vartable_ajax == 1 || $vartable_globalcart == 1) {
      if (isset($_SESSION['vtajaxfix']) && $_SESSION['vtajaxfix'] != 1) {
      $_SESSION['vtajaxfix'] = 1;
      
      ob_start();
      do_action('vartable_add_gc_button', $product->id);
      $vartable_add_gc_button = ob_get_clean();
      
    $out .= '
    <script type="text/javascript">
      jQuery(document).ready(function() {
          
          var gclicked = 0;
          jQuery("a#gc_'. $vtrand .''. $vartable_add_gc_button .'").on("click", function(event) {
            gclicked = 1;
          });
      
          jQuery(".wishcol a").on("click", function(event) {
          
            event.preventDefault();
            
            var wthis = jQuery(this);
            jQuery.ajax({
              type:"GET",
              url: wthis.attr("href"),
              success:function(data){
                wthis.css({"font-size":"125%", "opacity": "0.6"});
                '. ((($vartable_ajax != 1 &&  $vartable_globalcart == 1) || $cartredirect == 'yes') ? ''. $wheretoredirect .';' : '') .'
              }
            });
          });
        
          jQuery(document).on("submit", "form.vtajaxform", function(event) {

          
          
            console.log("triggered");
            event.preventDefault();
            
            if (jQuery(this).find(".hidden_quantity").val() > 0) {
              
              var addvtdata = jQuery(this).serialize();
              var thisid = jQuery(this).attr("data-variation_id");
              
              // console.log(addvtdata);

              jQuery.ajax({
                type:"POST",
                url: "'. get_site_url(get_current_blog_id()) .'/",
                data: addvtdata,
                success:function(data){
                  // console.log("Added: "+thisid);
                  jQuery("#added2cart_"+ thisid).fadeIn(200, function() {
                    jQuery("#added2cart_"+ thisid).delay(1000).fadeOut(1000);
                    '. ((($vartable_ajax != 1 &&  $vartable_globalcart == 1) || $cartredirect == 'yes') ? 'if (gclicked == 0) { '. $wheretoredirect .'; }' : '') .'
                  });
                }
              });
              
            }
            
            return false;
            
          });
        });
      </script>
      ';
      }
    }
    
    
    ob_start();
    do_action('vartable_after_table', $product->id);
    $vartable_after_table = ob_get_clean();
    
    ob_start();
    do_action('woocommerce_product_meta_end', $product->id);
    $woocommerce_product_meta_end = ob_get_clean();
    
    $out .= $vartable_after_table;
    $out .= $woocommerce_product_meta_end;
    
    if ($vartable_head == 1 && get_post_meta( $product->id, 'disable_variations_table_header', true ) != 1) {
    
      // order header
      $headenames = fields_func();
      $headenames['vartable_cart'] = '';
      $headenames = apply_filters( 'vartable_headenames', $headenames, $product->id);
      $orderedheader = array();
      
      if (is_array($vartable_order)) {
      
        if ($anyextraimg == 1 && get_post_meta( $product->id, 'disable_variations_table_offer', true ) != 1) {
          $vartable_order['vartable_offer'] = __('Offer Image', 'vartable');
        }
        $vi = 0;
        foreach ($vartable_order as $vokey => $vovalue) {
          if (($vokey == 'vartable_gift' && $is_wrappable != 'yes') || $vokey == 'vartable_sorting') {
            continue;
          }
          $sortingval = ' data-sort="string-ins" ';
          if ($vokey == 'vartable_thumb' || $vokey == 'vartable_gift' || $vokey == 'vartable_wishlist' || $vokey == 'vartable_cart' || $vokey == 'vartable_offer') {
            $sortingval = ' data-sort="string" ';
          }
      if ($vokey == 'vartable_globalcart' || $vokey == 'vartable_cart') {
            $sortingval = '';
          }
          if ($vokey == 'vartable_qty') {
            $sortingval = ' data-sort="int" ';
          }
          if ($vokey == 'vartable_price') {
            $sortingval = ' data-sort="float" ';
          }
          
          if ( (isset(${$vokey}) && ${$vokey} == 1) || ($vokey == 'vartable_offer' && $anyextraimg == 1) || $vokey == 'vartable_variations') {
            if ($vokey == 'vartable_variations') {
              
              foreach($attr_ordernames as $attrslug => $attrval) {
                
                ob_start();
                do_action('vartable_variations_th', $product->id, $attrslug);
                $vartable_variations_th = ob_get_clean();
                
                $orderedheader[$vokey] .= '
                  <th '. $sortingval .' class="'.$vokey .' '. $attrslug .'" '. $vartable_variations_th .'>
                    <span>
                      '. apply_filters( 'vartable_header_attributes_join' , $attrval, $product->id, $attrslug) .'
                    </span>
                  </th>
                  ';
              }
              
            } elseif ($vokey == 'vartable_globalcart' && $vartable_globalcart == 1) {
              $orderedheader[$vokey] = '<th '. $sortingval .'class="'.$vokey .'"><div class="vartable_selectall button btn"><label for="vtselectall_'. $vtrand .'">'. apply_filters( 'vartable_header_text' , __('Select All', 'vartable'), $product->id) .' <input class="vartable_selectall_check" id="vtselectall_'. $vtrand .'" type="checkbox" id="selecctall"/></label></div></th>';
            } else {
              $orderedheader[$vokey] = '<th '. $sortingval .' class="'.$vokey .'" ><span>'.apply_filters( 'vartable_header_text' , $headenames[$vokey], $product->id).'</span></th>';
            }
          }
          $vi++;
        }
      }
      
      if ($anyextraimg == 0) {
        unset($orderedheader['vartable_offer']);
        unset($allcolumns['vartable_offer']);
      }
      
      $joinedheader = implode('', apply_filters( 'vartable_header_th', $orderedheader, $product->id));
    
      if (get_post_meta( $product->id, 'custom_variations_table_header', true ) != '') {
        $head .= get_post_meta( $product->id, 'custom_variations_table_header', true );
      } elseif ($vartable_customhead != '' && get_post_meta( $product->id, 'custom_variations_table_header_skip', true ) != 1) {
        
        $head .= $vartable_customhead;
        
      } else {
      
        $head .= '<thead>
            <tr>
              '.
            $joinedheader
          .' 
            </tr>
          </thead>
        ';
      }
    }
    
    $out = str_replace('%headplaceholder%', $head, $out);
    if ($anyextraimg == 0) {
      $out = str_replace('<td class="offercol" data-label="'. apply_filters('vartable_dl_offer', $headenames['vartable_offer'], $product->id) .'"></td>', '', $out);
    }
    
    wp_reset_query();
    wp_reset_postdata();
    
    if($vartable_shortcd != 1) {
      echo $out;
    } else {
      return ($out);
    }
}



add_action("wp_enqueue_scripts", "woovartables_scripts", 20); 
function woovartables_scripts() {
  
  wp_register_style( 'woovartables_css', plugins_url('woovartables.css', __FILE__) );
  wp_enqueue_style('woovartables_css');
  
  if (isset($_GET['page']) && $_GET['page'] == 'variationstable') {
    wp_enqueue_script("jquery-ui-core");
    wp_enqueue_script("jquery-ui-sortable");
    wp_enqueue_script("jquery-ui-draggable");
    wp_enqueue_script("jquery-ui-droppable");
  }
     
  if (get_option('vartable_sorting') == 1) {
    wp_register_script( 'woovartables_table_sort', plugins_url('assets/js/stupidtable.min.js', __FILE__), array('jquery') );
    wp_enqueue_script("woovartables_table_sort");
    
    // wp_register_script( 'woovartables_js', plugins_url('woovartables.js',__FILE__ ), array( 'jquery' ));
    // wp_enqueue_script('woovartables_js');
  }
  
}



// add product custom fields
add_action( 'woocommerce_product_options_general_product_data', 'spyros_disable_table_product_option' );
function spyros_disable_table_product_option() {
    woocommerce_wp_select( 
    array( 
      'id'      => 'disable_variations_table', 
      'label'   => __( 'Disable variations table', 'vartable' ), 
      'options' => array(
        '0'   => __( 'No', 'vartable' ),
        '1'   => __( 'Yes', 'vartable' )
        )
      )
    );
    woocommerce_wp_select( 
    array( 
      'id'      => 'disable_variations_table_header', 
      'label'   => __( 'Disable variations table <strong>header</strong>', 'vartable' ), 
      'options' => array(
        '0'   => __( 'No', 'vartable' ),
        '1'   => __( 'Yes', 'vartable' )
        )
      )
    );
    woocommerce_wp_select( 
    array( 
      'id'      => 'disable_variations_table_offer', 
      'label'   => __( 'Disable variations table <strong>offer/extra image</strong>', 'vartable' ), 
      'options' => array(
        '0'   => __( 'No', 'vartable' ),
        '1'   => __( 'Yes', 'vartable' )
        )
      )
    );
    woocommerce_wp_select( 
    array( 
      'id'      => 'custom_variations_table_header_skip', 
      'label'   => __( 'Skip custom variations table <strong>header</strong> set on settings', 'vartable' ), 
      'options' => array(
        '0'   => __( 'No', 'vartable' ),
        '1'   => __( 'Yes', 'vartable' )
        ),
        'desc_tip'=> true,
        'description' => __('If set to yes it will replace the custom header that you may have set, on the settings page, with the default one, if you do not set a custom one for this product only.', 'vartable' )
      )
    );
    
    woocommerce_wp_textarea_input( 
    array( 
      'id'      => 'custom_variations_table_header', 
      'label'   => __( 'Custom variations table header html code', 'vartable' ),
      'desc_tip'=> true,
      'description' => __('This will replace the table header with your custom html code', 'vartable' )
      )
    );
}

add_action( 'save_post', 'spyros_save_table_product_option' );
function spyros_save_table_product_option( $product_id ) {
    // If this is a auto save do nothing, we only save when update button is clicked
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return;
  }
	if ( isset( $_POST['disable_variations_table'] ) ) {
		if ( is_numeric( $_POST['disable_variations_table'] ) ) {
			update_post_meta( $product_id, 'disable_variations_table', $_POST['disable_variations_table'] );
    }
	} else {
    delete_post_meta( $product_id, 'disable_variations_table' );
  }
  
  
  if ( isset( $_POST['disable_variations_table_header'] ) ) {
		if ( is_numeric( $_POST['disable_variations_table_header'] ) ) {
			update_post_meta( $product_id, 'disable_variations_table_header', $_POST['disable_variations_table_header'] );
    }
	} else {
    delete_post_meta( $product_id, 'disable_variations_table_header' );
  } 
  
  if ( isset( $_POST['disable_variations_table_offer'] ) ) {
		if ( is_numeric( $_POST['disable_variations_table_offer'] ) ) {
			update_post_meta( $product_id, 'disable_variations_table_offer', $_POST['disable_variations_table_offer'] );
    }
	} else {
    delete_post_meta( $product_id, 'disable_variations_table_offer' );
  }  
  
  if ( isset( $_POST['custom_variations_table_header_skip'] ) ) {
		if ( is_numeric( $_POST['custom_variations_table_header_skip'] ) ) {
			update_post_meta( $product_id, 'custom_variations_table_header_skip', $_POST['custom_variations_table_header_skip'] );
    }
	} else {
    delete_post_meta( $product_id, 'custom_variations_table_header_skip' );
  } 
  
  if ( isset( $_POST['custom_variations_table_header'] ) ) {
		update_post_meta( $product_id, 'custom_variations_table_header', $_POST['custom_variations_table_header'] );
	} else {
    delete_post_meta( $product_id, 'custom_variations_table_header' );
  }
}




//Display Fields
add_action( 'woocommerce_product_after_variable_attributes', 'vartable_variable_fields', 10, 3 );


function vartable_variable_fields( $loop, $variation_data, $variation ) {
  global $thepostid, $post;
  ?>
	<tr>
		<td>
      <br />
			<?php
// Checkbox

			woocommerce_wp_select( 
			array( 
				'id'            => 'enbable_variations_table_img['.$loop.']', 
				'label'         => __('Display Extra Image', 'vartable' ).' ', 
				'description'   => '',
				'value'         => get_post_meta($variation->ID, 'enbable_variations_table_img', true),
        'options' => array(
            '' => __('Default Settings', 'vartable'),
            'no' => __('No', 'vartable'),
            'yes' => __('Yes', 'woocommerce')
          )
				)
			);
			?>
		</td>
	</tr>
  <tr>
    <td>
      <label for="override_extra_image[<?php echo $loop; ?>]"><?php _e('Override extra image', 'vartable'); ?></label>
      <?php spyros_media_upload('override_extra_image['. $loop .']', get_post_meta($variation->ID, 'override_extra_image', true), $loop); ?>
    </td>
  </tr>
  
  <tr>
		<td>
			<?php

      // Step input

			woocommerce_wp_text_input( 
			array( 
				'id'            => 'vartable_qty_step['.$loop.']', 
				'label'         => __('Quantity Steps', 'vartable' ).' ', 
				'value'         => get_post_meta($variation->ID, 'vartable_qty_step', true)
				)
			);
			?>
		</td>
	</tr>
  
  <tr>
		<td>
			<?php
// Checkbox

			woocommerce_wp_textarea_input( 
			array( 
				'id'            => 'vt_variation_description['.$loop.']', 
				'label'         => __('Description', 'vartable' ).' ', 
				'value'         => get_post_meta($variation->ID, 'vt_variation_description', true)
				)
			);
			?>
		</td>
	</tr>
  <?php
}

//JS to add fields for new variations
add_action( 'woocommerce_product_after_variable_attributes_js', 'vartable_variable_fields_js' );

/**
 * Create new fields for new variations
 *
*/
function vartable_variable_fields_js() {
?>
	<tr>
		<td>
      <br />
			<?php
			// Checkbox

			woocommerce_wp_select( 
			array( 
				'id'            => 'enbable_variations_table_img[ + loop + ]', 
				'label'         => __('Display Extra Image', 'vartable' ).' ', 
				'description'   => '',
				'value'         => $variation_data['enbable_variations_table_img'][0],
        'options' => array(
            '' => __('Default Settings', 'vartable'),
            'no' => __('No', 'vartable'),
            'yes' => __('Yes', 'woocommerce')
          )
				)
			);
			?>
		</td>
	</tr>
  <tr>
    <td>
      <label for="override_extra_image[ + loop + ]"><?php _e('Override extra image', 'vartable'); ?></label>
      <?php spyros_media_upload('override_extra_image[ + loop + ]', $variation_data['override_extra_image'][0], '+ loop +'); ?>
    </td>
  </tr>
  
  <tr>
		<td>
			<?php
			// Checkbox

			woocommerce_wp_text_input( 
			array( 
				'id'            => 'vartable_qty_step[ + loop + ]', 
				'label'         => __('Quantity Steps', 'vartable' ).' ', 
				'description'   => '',
				'value'         => $variation_data['vartable_qty_step'][0]
				)
			);
			?>
		</td>
	</tr>
  
  <tr>
		<td>
			<?php
			// Checkbox

			woocommerce_wp_textarea_input( 
			array( 
				'id'            => 'vt_variation_description[ + loop + ]', 
				'label'         => __('Description', 'vartable' ).' ', 
				'description'   => '',
				'value'         => $variation_data['vt_variation_description'][0]
				)
			);
			?>
		</td>
	</tr>
  <?php
}
//Save variation fields
add_action( 'woocommerce_process_product_meta_variable', 'vartable_save_variable_fields', 10, 1 );
add_action( 'woocommerce_save_product_variation', 'vartable_save_variable_fields', 10, 1 );

/**
 * Save new fields for variations
 *
*/
function vartable_save_variable_fields( $post_id ) {
	if (isset( $_POST['variable_post_id'] ) ) {
    

		$variable_sku          = $_POST['variable_sku'];
		$variable_post_id      = $_POST['variable_post_id'];

    // Checkbox
		$enbable_variations_table_img = $_POST['enbable_variations_table_img'];
		$override_extra_image         = $_POST['override_extra_image'];
		$vartable_qty_step            = $_POST['vartable_qty_step'];
		$vt_variation_description     = $_POST['vt_variation_description'];
    
		for ( $i = 0; $i < sizeof( $variable_post_id ); $i++ ) {
			$variation_id = (int) $variable_post_id[$i];
			if ( isset( $enbable_variations_table_img[$i] ) ) {
				update_post_meta( $variation_id, 'enbable_variations_table_img', stripslashes( $enbable_variations_table_img[$i] ) );
			} else {
        if (isset($enbable_variations_table_img[$i])) {
          delete_post_meta( $variation_id, 'enbable_variations_table_img', stripslashes( $enbable_variations_table_img[$i] ) );
        }
      }
      if ( isset( $override_extra_image[$i] ) ) {
				update_post_meta( $variation_id, 'override_extra_image', stripslashes( $override_extra_image[$i] ) );
			} else {
        if ($override_extra_image[$i] == '') {
          delete_post_meta( $variation_id, 'override_extra_image', stripslashes( $override_extra_image[$i] ) );
        }
      }
      if ( isset( $vt_variation_description[$i] ) ) {
				update_post_meta( $variation_id, 'vt_variation_description', stripslashes( $vt_variation_description[$i] ) );
			} else {
        if ($vt_variation_description[$i] == '') {
          delete_post_meta( $variation_id, 'vt_variation_description', stripslashes( $vt_variation_description[$i] ) );
        }
      }
      if ( isset( $vartable_qty_step[$i] ) ) {
				update_post_meta( $variation_id, 'vartable_qty_step', stripslashes( $vartable_qty_step[$i] ) );
			} else {
        if ($vartable_qty_step[$i] == '') {
          delete_post_meta( $variation_id, 'vartable_qty_step', stripslashes( $vartable_qty_step[$i] ) );
        }
      }
		}
  }
}
    
    
    

function vartable_combinations($arrays, $i = 0) {
    $key = array_keys($arrays);
    if (!isset($arrays[$key[$i]])) {
        return array();
    }
    if ($i == count($arrays) - 1) {
        return $arrays[$key[$i]];
    }

    // get vartable_combinations from subsequent arrays
    $tmp = vartable_combinations($arrays, $i + 1);

    $result = array();

    // concat each array from tmp with each element from $arrays[$i]
    foreach ($arrays[$key[$i]] as $v) {
        foreach ($tmp as $t) {
            $result[] = is_array($t) ? 
                array_merge(array($key[$i] => $v), $t) :
                array($key[$i] => $v, $key[($i+1)] => $t);
        }
    }

    return $result;
}


/****
*  
  Get all cateogries
* 
****/
function woovartables_get_all_categories($selected) {
  global $wpdb;
  
  if (empty($selected)) { $selected = array(); }

  $output = '';
  
  $args = array(
    'hide_empty' => false
  );
  
  $terms = get_terms( 'product_cat', $args );
  
  if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
    foreach ( $terms as $term ) {
      $output .= '<option '. (in_array($term->term_id, $selected)? 'selected': '') .' value="'. $term->term_id .'">' . $term->name . '</option>';
    }

  }
  
  return $output;
}


function spyros_media_upload($fname, $value = '', $ai='') {
 
// This will enqueue the Media Uploader script
wp_enqueue_media();
?>
    <div>
    <input type="text" name="<?php echo $fname; ?>" id="<?php echo $fname; ?>" value="<?php echo $value; ?>" class="regular-text">
    <input type="button" name="upload-btn<?php echo $ai; ?>" id="upload-btn<?php echo $ai; ?>" class="button-secondary button button-action" value="<?php echo __('Open Media Manager', 'vartable'); ?>"><br />
    <img class="img_<?php echo $ai; ?>" src="<?php echo $value; ?>" />

</div>
<script type="text/javascript">
jQuery(document).ready(function($){
    jQuery('#upload-btn<?php echo $ai; ?>').click(function(e) {
        e.preventDefault();
        var image = wp.media({ 
            title: 'Upload Image',
            // mutiple: true if you want to upload multiple files at once
            multiple: false
        }).open()
        .on('select', function(e){
            // This will return the selected image from the Media Uploader, the result is an object
            var uploaded_image = image.state().get('selection').first();
            // We convert uploaded_image to a JSON object to make accessing it easier
            // Output to the console uploaded_image
            // console.log(uploaded_image);
            var image_url = uploaded_image.toJSON().url;
            // console.log(image_url);
            // Let's assign the url value to the input field
            jQuery('input[name="<?php echo $fname; ?>"]').val(image_url);
            jQuery('img.img_<?php echo $ai; ?>').attr('src', image_url);
        });
    });
});
</script>
  <?php
}


// Add settings link on plugin page
function vartable_plugin_settings_link($links) { 
  $settings_link = '<a href="admin.php?page=variationstable">'. __('Settings', 'vartable') .'</a>'; 
  array_unshift($links, $settings_link); 
  return $links; 
}
 
$vartable_plugin = plugin_basename(__FILE__); 
add_filter("plugin_action_links_$vartable_plugin", 'vartable_plugin_settings_link' );

function vt_resetajaxfix() {
 $_SESSION['vtajaxfix'] = 0; 
}
add_action('wp_footer', 'vt_resetajaxfix');


// remove gift wrap frontend hook
require_once 'wp-filters-extra.php';
function vartable_gifthook_the_remove() {
  if (class_exists('WC_Product_Gift_Wrap')) {
    vartable_remove_filters_for_anonymous_class( 'woocommerce_after_add_to_cart_button', 'WC_Product_Gift_Wrap', 'gift_option_html', 10 );
  }
}

add_action( 'plugins_loaded', 'vartable_gifthook_the_remove', 1) ;

function vtdb($out) {
  if ( is_user_logged_in() ) {
    $out = '<pre>'.print_r($out, true).'</pre>';
  }
  return $out;
}
?>